#include <windows.h>
#include "ittnotify.h"
__itt_domain* domain;
__itt_string_handle* shMyTask;
__itt_string_handle* shMySubtask;
const int num_threads = 4;
DWORD WINAPI foo(LPVOID pArg)
{
    int myNum = *((int *)pArg);
    // Only 3rd thread masked
    if (myNum == 2) __itt_task_begin(domain, __itt_null, __itt_null, shMySubtask);
    for (volatile unsigned long i = 0; i<60000000000L; i++); // Should use "/Od" to avoid "zero" workload
    if (myNum == 2)__itt_task_end(domain);
    return 1;

}
int main()
{
    HANDLE threadHandles[num_threads];
    int tNum[num_threads];
    domain = __itt_domain_create("MyTraces.MyDomain");
    shMyTask = __itt_string_handle_create("My Task");
    shMySubtask = __itt_string_handle_create("My SubTask");
    __itt_task_begin(domain, __itt_null, __itt_null, shMyTask);
    for (int i = 0; i<num_threads; ++i)
    {
        tNum[i] = i;
        threadHandles[i] = CreateThread(NULL,            // Security attributes
            0,               // Stack size
            foo,      // Thread function
            (LPVOID)&tNum[i],// Data for thread func()
            0,               // Thread start mode
            NULL);           // Returned thread ID
    }
    WaitForMultipleObjects(num_threads, threadHandles, TRUE, INFINITE);

    __itt_task_end(domain);
    return 1;
}
